{**********************************************************************}
{*                    ⥭    DBF 䠩                     *}
{*                             ᮢ ..                   *}
{**********************************************************************}
unit DBF;
interface
const
  MaxKolPol=128;         { ᨬ쭮 ⢮    }
type
   Num=^integer;

  Zagolovok=record        {    }
   Byte0:byte;
   God:byte;              {  ᫥ 䨪樨 }
   Mes:Byte;              {  }
   Den:Byte;              {  }
   KolZap:longint;        { . ᥩ }
   DlZag:integer;         {   }
   DlZap:Integer;         {   }
   Rezerv2:array [1..20] of byte;
  end;

  Pole=record          {  ᠭ  }
   ImePol:array [1..11] of char;  {   }
   TipPol:char;                   {   }
   Rezerv:array [1..4] of byte;
   DlPol:byte;                    {   }
   KolDecR:byte;                  { ⢮ ࠧ冷 ᫥ ⮩ }
   Rezerv2:array [1..14] of byte;
  end;

  StructBaza=record
    KolPol:Integer;                          { .  }
    ImP:array [1..MaxKolPol] of string [11]; {   }
    TypPole:array [1..MaxKolPol] of char;    {   }
    RazmPol:array [1..MaxKolPol] of byte;    {   }
    DecZn:  array [1..MaxKolPol] of byte;    { . }
  end;

  PBazaDbf=^BazaDbf;
  BazaDBF=object
    Z:Zagolovok;                    {  }
    P:Pole;                         {   }
    Stb:StructBaza;                 { ࠬ   }
    BazaDan:file;                   {    }

     {. 䠩   OpenBaza(   䠩) }
    procedure OpenBaza(ImeFile:string);

     {     ReadPole( , ):祭 }
    function ReadPole(NomPol:byte;NomZap:longint):string;

     {    WritePole( , ,祭 ) }
    procedure WritePole(NomPol:byte;NomZap:longint;ZnPole:string);

     {  }
    procedure CloseBaza;

  end;

var
  B:BazaDBF;

implementation

       {******************************** ࠢ  ࠡ   }

procedure BazaDbf.OpenBaza(ImeFile:string);
     {        }
   var
     J,I:integer;
   begin
     assign(BazaDan,ImeFile);
     reset(BazaDan,1);
     BlockRead(BazaDan,Z,SizeOf(Z));
     J:=0;
     repeat
       BlockRead(BazaDan,P,SizeOf(P));
       J:=J+1;  I:=1; Stb.ImP[J]:='';
       while  P.ImePol[I]<>#0 do begin
          Stb.ImP[J]:=Stb.ImP[J]+P.ImePol[I];  I:=I+1;
       end;
       With Stb do begin
         TypPole [J]:=P.TipPol;
         RazmPol [J]:=P.DlPol;
         DecZn   [J]:=P.KolDecR;
       end;
     until FilePos(BazaDan)>=Z.DlZag-32;
     Stb.KolPol:=J;
end; {OpenBaza}

function  BazaDbf.ReadPole(NomPol:byte;NomZap:longint):string;
   {     }
   var
     Pole:string;
     MestoPol,I:longint;
   begin
     if NomPol>Stb.KolPol then begin
       Writeln('   祬   ');
       Halt;
     end;

     if NomZap>Z.KolZap then begin
       Writeln('   祬 ᥩ  ');
       Halt;
     end;

     MestoPol:=0;
     for I:=2 to NomPol do  MestoPol:=MestoPol+Stb.RazmPol[I-1];
     MestoPol:=MestoPol+(NomZap-1)*Z.DlZap+Z.DlZag;
     Seek(BazaDan,MestoPol);
     BlockRead(BazaDan,Pole,Stb.RazmPol[NomPol]+1);
     ReadPole:=Copy(Pole,1,Stb.RazmPol[NomPol]);
end;

procedure BazaDbf.WritePole(NomPol:byte;NomZap:longint;ZnPole:string);
   {     }
   var
     Pole:string;
     Sim:char;
     MestoPol,I:longint;
   begin
     if NomPol>Stb.KolPol then begin
        Writeln('   祬   ');
        Halt;
     end;
     if NomZap>Z.KolZap+1 then begin
        Writeln('   祬 ᥩ  ');
        Halt;
     end;
     if NomZap=Z.KolZap+1 then begin
         Seek(BazaDan,4);
         BlockWrite (BazaDan,NomZap,4);
         Z.KolZap:=NomZap;
         Seek(BazaDan,((NomZap-1)*Z.DlZap+Z.DlZag));
         Sim:=' ';
         BlockWrite (BazaDan,Sim,1);
         Seek(BazaDan,(NomZap*Z.DlZap+Z.DlZag));
         Sim:=Chr(246);
         BlockWrite (BazaDan,Sim,1);
     end;
     MestoPol:=1;
     for I:=2 to NomPol do  MestoPol:=MestoPol+Stb.RazmPol[I-1];
     MestoPol:=MestoPol+(NomZap-1)*Z.DlZap+Z.DlZag;
     Seek(BazaDan,MestoPol);
     Pole:=Copy(ZnPole,1,Stb.RazmPol[NomPol]);
     case  Stb.TypPole[NomPol] of
      'N':while Length(Pole)<Stb.RazmPol[NomPol] do  Insert(' ',Pole,1);
      'C','D':while Length(Pole)<Stb.RazmPol[NomPol] do
                          Insert(' ',Pole,Length(Pole)+1);
     end;
     for I:=1 to Stb.RazmPol[NomPol] do begin
       Sim:=Chr(Mem[Seg(Pole):(Ofs(Pole)+I)]);
       BlockWrite (BazaDan,Sim,1);
     end;
end;

     {  }
procedure BazaDbf.CloseBaza;
  begin
    Close(BazaDan);
end;

end.
